VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Subclass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Public Event WindowsMessage(Message As WindowsMessages, wParam As Long, lParam As Long, Result As Long)
Private r_lngHandle As Long
Private r_smsMessages As SubclassMsgs
Private r_booAttached As Boolean

Public Property Get Handle() As Long
    Handle = r_lngHandle
End Property

Public Property Let Handle(ByVal v_lngHandle As Long)
    If r_lngHandle = v_lngHandle Then _
        Exit Property
    If Attached Then
        DetachSubclass Me
    End If
    r_lngHandle = v_lngHandle
    AttachSubclass Me
    Attached = True
End Property

Public Property Get Messages() As SubclassMsgs
    Set Messages = r_smsMessages
End Property

Public Property Let Messages(ByVal v_smsMessages As SubclassMsgs)
    Set r_smsMessages = v_smsMessages
End Property

Private Sub Class_Initialize()
    Set r_smsMessages = New SubclassMsgs
End Sub

Private Sub Class_Terminate()
    If Attached Then
        DetachSubclass Me
    End If
    Set r_smsMessages = Nothing
End Sub

Public Property Get Attached() As Boolean
    Attached = r_booAttached
End Property

Friend Property Let Attached(ByVal v_booAttached As Boolean)
    r_booAttached = v_booAttached
End Property

Friend Function Invoke(Message As Long, wParam As Long, lParam As Long) As Long
    Dim Result As Long
    RaiseEvent WindowsMessage(Message, wParam, lParam, Result)
    Invoke = Result
End Function
